#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>
#include <string.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20100216

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)

#define YYPREFIX "yy"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
#ifdef YYPARSE_PARAM_TYPE
#define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
#else
#define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
#endif
#else
#define YYPARSE_DECL() yyparse(void)
#endif /* YYPARSE_PARAM */

extern int YYPARSE_DECL();

#line 2 "./grammar.y"
/*
 * Copyright (C) 1997 and 1998 WIDE Project.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 * $Id: grammar.y,v 1.50 2008/01/18 17:43:20 nishida Exp $
 */
/*
 * partly derived from lbl libpcap source code, which has the following
 * copyright notice:
 */
/*
 * Copyright (c) 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by the University of California,
 * Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
 * the University nor the names of its contributors may be used to endorse
 * or promote products derived from this software without specific prior
 * written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "mgp.h"
#ifdef HAVE_STDARG_H
#include <stdarg.h>
#else
#include <varargs.h>
#endif

#if 0
#define QSET(q, p, d, a) (q).proto = (p),\
			 (q).dir = (d),\
			 (q).addr = (a)

static struct qual qerr = { Q_UNDEF, Q_UNDEF, Q_UNDEF, Q_UNDEF };
#endif

int n_errors = 0;
struct ctrl *root;
char *yyfilename;
int yylineno;

#ifdef HAVE_STDARG_H
/* GCC complains if we declare this function in traditional style */
void
yyerror(char *msg, ...)
#else
void
yyerror(msg)
	char *msg;
#endif
{
	va_list ap;
#ifdef HAVE_STDARG_H
	va_start(ap, msg);
#else
	va_start(ap);
#endif
	++n_errors;
	fprintf(stderr, "%s:%d: error: ", yyfilename, yylineno);
	vfprintf(stderr, msg, ap);
	fprintf(stderr, "\n");
	va_end(ap);
}

#ifdef HAVE_STDARG_H
/* GCC complains if we declare this function in traditional style */
static void
yywarn(char *msg, ...)
#else
static void
yywarn(msg)
	char *msg;
#endif
{
	va_list ap;
#ifdef HAVE_STDARG_H
	va_start(ap, msg);
#else
	va_start(ap);
#endif
	fprintf(stderr, "%s:%d: warning: ", yyfilename, yylineno);
	vfprintf(stderr, msg, ap);
	fprintf(stderr, "\n");
	va_end(ap);
}

static struct ctrl *
gen_void(op)
	int op;
{
	struct ctrl *ct;

	if (!(ct = ctlalloc1(op))) {
		yyerror("cannot allocate void node");
		return ct;
	}
	return ct;
}

static struct ctrl *
gen_double_int(op, v)
	int op;
	int v;
{
	struct ctrl *ct;

	if (!(ct = ctlalloc1(op))) {
		yyerror("cannot allocate double node");
		return ct;
	}
	ct->ctf_value = (double)v;
	return ct;
}

static struct ctrl *
gen_double(op, v)
	int op;
	double v;
{
	struct ctrl *ct;

	if (!(ct = ctlalloc1(op))) {
		yyerror("cannot allocate double node");
		return ct;
	}
	ct->ctf_value = v;
	return ct;
}

static struct ctrl *
gen_int(op, v)
	int op;
	int v;
{
	struct ctrl *ct;

	if (!(ct = ctlalloc1(op))) {
		yyerror("cannot allocate integer node");
		return ct;
	}
	ct->cti_value = v;
	return ct;
}

static struct ctrl *
gen_int2(op, v1, v2)
       int op;
       int v1;
       int v2;
{
       struct ctrl *ct;

       if (!(ct = ctlalloc1(op))) {
               yyerror("cannot allocate integer2 node");
               return ct;
       }
       ct->cti2_value1 = v1;
       ct->cti2_value2 = v2;
       return ct;
}

static struct ctrl *
gen_int3(op, v1, v2, v3)
       int op;
       int v1;
       int v2;
       int v3;
{
       struct ctrl *ct;

       if (!(ct = ctlalloc1(op))) {
               yyerror("cannot allocate integer3 node");
               return ct;
       }
       ct->cti3_value1 = v1;
       ct->cti3_value2 = v2;
       ct->cti3_value3 = v3;   
       return ct;
}

static struct ctrl *
gen_str(op, str)
	int op;
	char *str;
{
	struct ctrl *ct;

	if (!(ct = ctlalloc1(op))) {
		yyerror("cannot allocate str1 node");
		return ct;
	}
	ct->ctc_value = strdup(str);
	return ct;
}

static struct ctrl *
gen_str2(op, str1, str2)
	int op;
	char *str1;
	char *str2;
{
	struct ctrl *ct;

	if (!(ct = ctlalloc1(op))) {
		yyerror("cannot allocate str2 node");
		return ct;
	}
	ct->ctc2_value1 = strdup(str1);
	ct->ctc2_value2 = strdup(str2);
	return ct;
}

static struct ctrl *
gen_color(op, color)
	int op;
	char *color;
{
	struct ctrl *ct;

	if (!(ct = ctlalloc1(op))) {
		yyerror("cannot allocate color node");
		return ct;
	}
	if (get_color(color, &ct->ctl_value) < 0)
		yyerror("cannot allocate color \"%s\"", color);
	return ct;
}

static struct ctrl *
gen_bgrad(w, h, colors, dir, zoomflg, extra)
	int w;
	int h;
	int colors;
	int dir;
	int zoomflg;
	struct ctrl *extra;
{
	struct ctrl *ct;
	struct ctrl *p;
	int siz;

	if (!(ct = ctlalloc1(CTL_BGRAD))) {
		yyerror("cannot allocate node (op=BGRAD)");
		return ct;
	}
	ct->ctd_width = w;
	ct->ctd_height = h;
	ct->ctd_numcolor = colors;
	ct->ctd_dir = dir;
	ct->ctd_zoomflag = zoomflg;

	/* process color list. */
	siz = ct->ctd_g_colors = 0;
	for (p = extra; p; p = p->ct_next)
		siz++;
	if (siz <= 2) {
		ct->ct_val.ctrl_grad.colors =
			malloc(3 * sizeof(struct gcolor *));
	} else {
		ct->ct_val.ctrl_grad.colors =
			malloc((siz + 1) * sizeof(struct gcolor *));
	}
	if (!ct->ct_val.ctrl_grad.colors) {
		yyerror("cannot allocate color table");
		return ct;
	}

	ct->ctd_g_colors = 2;
	ct->ct_val.ctrl_grad.colors[0] = name2gcolor(DEFAULT_GRADSTART);
	ct->ct_val.ctrl_grad.colors[1] = name2gcolor(DEFAULT_GRADEND);
	switch (siz) {
	case 0:
		break;
	case 1:
		ct->ct_val.ctrl_grad.colors[0] = name2gcolor(extra->ctc_value);
		break;
	default:
		ct->ctd_g_colors = siz;
		siz = 0;
		for (p = extra; p; p = p->ct_next) {
			ct->ct_val.ctrl_grad.colors[siz] =
				name2gcolor(p->ctc_value);
			siz++;
		}
	}

	/* normalize */
	if (ct->ctd_dir < 0) {	/*circle*/
		ct->ctd_mode = 1;
		ct->ctd_dir = abs(ct->ctd_dir);
	} else			/*linear*/
		ct->ctd_mode = 0;
	while (ct->ctd_dir < 0)
		ct->ctd_dir += 360;
	ct->ctd_dir %= 360;
	if (ct->ctd_width <= 0)
		ct->ctd_width = 100;
	if (ct->ctd_height <= 0)
		ct->ctd_height = 100;

	if (extra)
		ctlfree(extra);

	return ct;
}

static struct ctrl *
gen_newimage(arg)
	struct ctrl *arg;
{
	struct ctrl *p;
	struct ctrl *ct;

	if (!(ct = ctlalloc1(CTL_IMAGE))) {
		yyerror("cannot allocate node (op=IMAGE)");
		return ct;
	}

	/* default setting */
	ct->ctm_ximagesize = 100;
	ct->ctm_yimagesize = 100;
	ct->ctm_zoomflag = Z_NORMAL | (Z_NORMAL << Z_YSHIFT);
	ct->ctm_raise = 0;
	ct->ctm_rotate = 0;
	ct->ctm_zoomonclk = 0;

	for (p = arg; p; p = p->ct_next) {
		if (p->ctc_value[0] != '-')
			break;

		if (strcmp(p->ctc_value, "-colors") == 0 && p->ct_next) {
			p = p->ct_next;
			ct->ctm_numcolor = atoi(p->ctc_value);
		} else if (strcmp(p->ctc_value, "-xysize") == 0
			&& p->ct_next && p->ct_next->ct_next) {
			p = p->ct_next;
			ct->ctm_ximagesize = atoi(p->ctc_value);
			p = p->ct_next;
			ct->ctm_yimagesize = atoi(p->ctc_value);
			ct->ctm_zoomflag = Z_ABSOLUTE | (Z_ABSOLUTE << Z_YSHIFT);
		} else if (strcmp(p->ctc_value, "-zoom") == 0 && p->ct_next) {
			p = p->ct_next;
			ct->ctm_ximagesize = atoi(p->ctc_value);
			ct->ctm_yimagesize = atoi(p->ctc_value);
			ct->ctm_zoomflag = Z_NORMAL | (Z_NORMAL << Z_YSHIFT);
		} else if (strcmp(p->ctc_value, "-xyzoom") == 0
			&& p->ct_next && p->ct_next->ct_next) {
			p = p->ct_next;
			ct->ctm_ximagesize = atoi(p->ctc_value);
			p = p->ct_next;
			ct->ctm_yimagesize = atoi(p->ctc_value);
			ct->ctm_zoomflag = Z_NORMAL | (Z_NORMAL << Z_YSHIFT);
		} else if (strcmp(p->ctc_value, "-scrzoom") == 0 && p->ct_next) {
			p = p->ct_next;
			ct->ctm_ximagesize = atoi(p->ctc_value);
			ct->ctm_yimagesize = atoi(p->ctc_value);
			ct->ctm_zoomflag = Z_SCREEN | (Z_SCREEN << Z_YSHIFT);
		} else if (strcmp(p->ctc_value, "-xscrzoom") == 0 && p->ct_next) {
			p = p->ct_next;
			ct->ctm_ximagesize = atoi(p->ctc_value);
			ct->ctm_yimagesize = 100;
			ct->ctm_zoomflag = Z_SCREEN | (Z_OBEY << Z_YSHIFT);
		} else if (strcmp(p->ctc_value, "-yscrzoom") == 0 && p->ct_next) {
			p = p->ct_next;
			ct->ctm_ximagesize = 100;
			ct->ctm_yimagesize = atoi(p->ctc_value);
			ct->ctm_zoomflag = Z_OBEY | (Z_SCREEN << Z_YSHIFT);
		} else if (strcmp(p->ctc_value, "-xyscrzoom") == 0
			&& p->ct_next && p->ct_next->ct_next) {
			p = p->ct_next;
			ct->ctm_ximagesize = atoi(p->ctc_value);
			p = p->ct_next;
			ct->ctm_yimagesize = atoi(p->ctc_value);
			ct->ctm_zoomflag = Z_SCREEN | (Z_SCREEN << Z_YSHIFT);
		} else if (strcmp(p->ctc_value, "-raise") == 0 && p->ct_next) {
			p = p->ct_next;
			ct->ctm_raise = atoi(p->ctc_value);
		} else if (strcmp(p->ctc_value, "-rotate") == 0 && p->ct_next) {
			p = p->ct_next;
			ct->ctm_rotate = atoi(p->ctc_value);
		} else if (strcmp(p->ctc_value, "-zoomonclk") == 0 && p->ct_next) {
			p = p->ct_next;
#ifdef USE_IMLIB
			ct->ctm_zoomonclk = atoi(p->ctc_value);
#else
			fprintf(stderr, "warning: cannot use -zoomonclk option in this configuration\n");
#endif
		} else {
			yyerror("invalid argument %s specified for newimage",
				p->ctc_value);
			return ct;
		}
	}

	if (!p) {
		yyerror("no filename specified to newimage");
		return ct;
	}

	if (p->ct_next) {
		yyerror("multiple filename specified to newimage");
		return ct;
	}

	ct->ctm_fname = embed_fname(p->ctc_value);
	if (mgpwdirname[0] != '\0'
	 && strncmp(mgpwdirname, ct->ctm_fname, strlen(mgpwdirname)) == 0)
		;	/* do not chkfile() */
	else
		chkfile(ct->ctm_fname);

	return ct;
}

static struct ctrl *
gen_image(op, fname, colors, xsiz, ysiz, zoomflg)
	int op;
	char *fname;
	int colors;
	int xsiz;
	int ysiz;
	int zoomflg;
{
	struct ctrl *ct;

	if (!(ct = ctlalloc1(op))) {
		yyerror("cannot allocate node (op=IMAGE)");
		return ct;
	}
	ct->ctm_fname = embed_fname(fname);
	ct->ctm_numcolor = colors;
	ct->ctm_ximagesize = xsiz;
	ct->ctm_yimagesize = ysiz;
	switch (zoomflg) {
	case 0:
		ct->ctm_zoomflag = 0;
		if (ct->ctm_ximagesize == 0) {
			ct->ctm_ximagesize = 100;
			ct->ctm_zoomflag |= Z_NORMAL;
		} else
			ct->ctm_zoomflag |= Z_SCREEN;
		if (ct->ctm_yimagesize == 0) {
			ct->ctm_yimagesize = 100;
			ct->ctm_zoomflag |= (Z_NORMAL << Z_YSHIFT);
		} else
			ct->ctm_zoomflag |= (Z_SCREEN << Z_YSHIFT);
		break;
	case 1:
		ct->ctm_zoomflag = Z_NORMAL | (Z_NORMAL << Z_YSHIFT);
		break;
	case 2:
		ct->ctm_zoomflag = Z_SCREEN0 | (Z_SCREEN0 << Z_YSHIFT);
		break;
	}
	if (mgpwdirname[0] != '\0' &&
	    strncmp(mgpwdirname, ct->ctm_fname, strlen(mgpwdirname)) == 0)
		;	/* do not chkfile() */
	else
		chkfile(ct->ctm_fname);
	return ct;
}

static struct ctrl *
gen_bar(color, thick, start, len)
	char *color;
	int thick;
	int start;
	int len;
{
	struct ctrl *ct;

	if (!(ct = ctlalloc1(CTL_BAR))) {
		yyerror("cannot allocate node (op=BAR)");
		return ct;
	}
	if (get_color(color, &ct->ctb_color) < 0)
		yyerror("cannot allocate color %s", color);
	ct->ctb_width = thick;
	ct->ctb_start = start;
	ct->ctb_length = len;

	/* normalize */
	if (ct->ctb_width < 0)
		ct->ctb_width = 0;
	else if (1000 < ct->ctb_width)
		ct->ctb_width = 1000;
	if (ct->ctb_start < 0)
		ct->ctb_start = 0;
	else if (100 < ct->ctb_start)
		ct->ctb_start = 100;
	if (100 < ct->ctb_start + ct->ctb_length)
		ct->ctb_length = 100 - ct->ctb_start;

	return ct;
}

static struct ctrl *
gen_icon(n, color, siz)
	char *n;
	char *color;
	int siz;
{
	struct ctrl *ct;

	if (!(ct = ctlalloc1(CTL_ICON))) {
		yyerror("cannot allocate node (op=ICON)");
		return ct;
	}
	ct->ctic_value = n;
	if (get_color(color, &ct->ctic_color) < 0)
		yyerror("cannot allocate color %s", color);
	ct->ctic_size = siz;
	return ct;
}

static struct ctrl *
gen_pcache(flag, mode, effect, value)
	int	flag;
	int	mode;
	int	effect;
	int	value;
{
	struct ctrl *ct;

	if (!(ct = ctlalloc1(CTL_PCACHE))) {
		yyerror("cannot allocate node (op=PCACHE)");
		return ct;
	}
	ct->ctch_flag = flag;
	ct->ctch_mode = mode;
	ct->ctch_effect = effect;
	ct->ctch_value = value;

	return ct;
}

static struct ctrl *
gen_valign(align)
	char *align;
{
	struct ctrl *ct;

	if (!(ct = ctlalloc1(CTL_VALIGN))) {
		yyerror("cannot allocate node (op=VALIGN)");
		return ct;
	}
	if (!strcmp(align, "center")) 
		ct->cti_value = VL_CENTER;
	else { 
		if (!strcmp(align, "top")) 
			ct->cti_value = VL_TOP;
		else {
			if (!strcmp(align, "bottom")) 
				ct->cti_value = VL_BOTTOM;
			else {
				yyerror("%valign center|top|bottom");
				ctlfree(ct);
				return NULL;
			}
		}
	}
	return ct;
}

static struct ctrl *
gen_area(width, height, xoff, yoff)
	int width;
	int height;
	int xoff;
	int yoff;
{
	struct ctrl *ct;

	if (!(ct = ctlalloc1(CTL_AREA))) {
		yyerror("cannot allocate node (op=AREA)");
		return ct;
	}
	if (width < 0 || width > 100)
		width = 100;
	if (height < 0 || height > 100)
		height = 100;
	if (xoff < 0)
		xoff = (100 - width) / 2;
	else if (width + xoff > 100)
		xoff = 100 - width;
	if (yoff < 0)
		yoff = (100 - height) / 2;
#ifdef notdef	/* mgp doesn't check overflow in y axis, anyway. */
	else if (height + yoff > 100)
		yoff = 100 - height;
#endif
	ct->ctar_width = width;
	ct->ctar_height = height;
	ct->ctar_xoff = xoff;
	ct->ctar_yoff = yoff;
	return ct;
}

#if 0

static struct ctrl *
gen_argsfromnid(op, nid)
	int op;
	struct ctrl *nid;
{
	struct ctrl *ct;
	struct ctrl *p;
	int siz;

	if (!(ct = ctlalloc1(op))) {
		yyerror("cannot allocate args node");
		return ct;
	}

	siz = 0;
	for (p = nid; p; p = p->ct_next)
		siz++;
	ct->cta_argc = siz;
	ct->cta_argv = malloc((siz + 1) * sizeof(char *));
	if (!ct->cta_argv) {
		yyerror("cannot allocate args table");
		return ct;
	}
	siz = 0;
	for (p = nid; p; p = p->ct_next) {
		ct->cta_argv[siz] = strdup(p->ctc_value);
		siz++;
	}
	ct->cta_argv[siz] = NULL;

	if (nid)
		ctlfree(nid);

	return ct;
}

#endif

static struct ctrl *
gen_argsfromstr(op, str, flag)
	int op;
	char *str;
	int flag;
{
	struct ctrl *ct;
	int siz;
	char **h;

	if (!(ct = ctlalloc1(op))) {
		yyerror("cannot allocate args node");
		return ct;
	}

	ct->cta_argc = 0;
	ct->cta_argv = malloc((siz = 16) * sizeof(char *));	/*initial siz*/
	ct->cta_flag = flag;
	if (!ct->cta_argv) {
		yyerror("cannot allocate args table");
		return ct;
	}
	for (h = (char **)ct->cta_argv;
	     (*h = strsep((char **)&str, " "));
	     /*none*/) {
		if (**h != '\0') {
			h++;
			ct->cta_argc++;
			if (siz < ct->cta_argc + 2) {
				siz *= 2;
				ct->cta_argv = realloc(ct->cta_argv,
					siz * sizeof(char *));
				if (!ct->cta_argv) {
					yyerror("cannot allocate args table");
					return ct;
				}
			}
		}
	}
	ct->cta_argv[ct->cta_argc] = NULL;

	return ct;
}

static void
check_xfont(seed, registry)
	char *seed;
	char *registry;
{
	int hyphen;
	char *p;

	hyphen = 0;
	for (p = seed; *p; p++) {
		if (*p == '-')
			hyphen++;
	}
	switch (hyphen) {
	case 0:
	case 1:
	case 2:
	case XLFD_HYPHEN:
		break;
	default:
		yyerror("invalid XFONT seed <%s>", seed);
		break;
	}

	hyphen = 0;
	for (p = registry; *p; p++) {
		if (*p == '-')
			hyphen++;
	}
	switch (hyphen) {
	case 0:
	case 1:
		break;
	default:
		yyerror("invalid XFONT registry <%s>", registry);
		break;
	}
}


#if 0	/*YYBISON*/
int yyparse __P((void));

int
pcap_parse()
{
	return (yyparse());
}
#endif

#line 771 "./grammar.y"
typedef union {
	int i;
	double d;
	char *s;
	struct ctrl *ct;
} YYSTYPE;
#line 809 "y.tab.c"
#define COMMA 257
#define NUM 258
#define DOUBLE 259
#define ID 260
#define STR 261
#define WINSIZ 262
#define KW_NOOP 263
#define KW_DEFAULT 264
#define KW_TAB 265
#define KW_SIZE 266
#define KW_FORE 267
#define KW_BACK 268
#define KW_LEFT 269
#define KW_CENTER 270
#define KW_RIGHT 271
#define KW_SHRINK 272
#define KW_LCUTIN 273
#define KW_RCUTIN 274
#define KW_CONT 275
#define KW_NODEF 276
#define KW_XFONT 277
#define KW_VFONT 278
#define KW_IMAGE 279
#define KW_BIMAGE 280
#define KW_PAGE 281
#define KW_HGAP 282
#define KW_VGAP 283
#define KW_GAP 284
#define KW_PAUSE 285
#define KW_PREFIX 286
#define KW_AGAIN 287
#define KW_CCOLOR 288
#define KW_BAR 289
#define KW_INCLUDE 290
#define KW_BGRAD 291
#define KW_TEXT 292
#define KW_LINESTART 293
#define KW_LINEEND 294
#define KW_MARK 295
#define KW_SYSTEM 296
#define KW_FILTER 297
#define KW_ENDFILTER 298
#define KW_QUALITY 299
#define KW_ICON 300
#define KW_LEFTFILL 301
#define KW_XSYSTEM 302
#define KW_VFCAP 303
#define KW_TFONT 304
#define KW_TFDIR 305
#define KW_TSYSTEM 306
#define KW_DEFFONT 307
#define KW_FONT 308
#define KW_TFONT0 309
#define KW_EMBED 310
#define KW_ENDEMBED 311
#define KW_NEWIMAGE 312
#define KW_PSFONT 313
#define KW_CHARSET 314
#define KW_TMFONT 315
#define KW_PCACHE 316
#define KW_TMFONT0 317
#define KW_ANIM 318
#define KW_VALIGN 319
#define KW_AREA 320
#define KW_OPAQUE 321
#define KW_SUP 322
#define KW_SUB 323
#define KW_SETSUP 324
#define KW_M17N 325
#define YYERRCODE 256
static const short yylhs[] = {                           -1,
    0,    0,    0,    0,    0,    1,    1,    2,    3,    5,
   13,   13,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,   10,   10,   11,   11,   12,   12,   12,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    8,    8,    7,    9,
   14,   14,
};
static const short yylen[] = {                            2,
    1,    1,    1,    1,    1,    1,    3,    2,    2,    2,
    1,    1,    3,    2,    3,    2,    3,    2,    2,    1,
    2,    2,    1,    2,    1,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    4,    1,    1,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    7,    6,    5,    4,    3,
    2,    1,    2,    3,    2,    3,    2,    2,    2,    3,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    3,
    4,    6,    5,    4,    3,    2,    5,    4,    3,    2,
    1,    4,    4,    2,    2,    2,    2,    2,    3,    5,
    5,    2,    2,    3,    2,    2,    2,    2,    2,    2,
    0,    0,
};
static const short yydefred[] = {                         0,
   30,    0,    0,    0,    0,    0,   31,   34,   33,   35,
   36,   37,   38,   39,    0,    0,    0,    0,   43,    0,
    0,    0,   40,    0,   41,    0,    0,    0,    0,    0,
   42,    0,    0,   20,    0,    0,   32,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   45,   46,    0,
    0,    0,    1,    2,    3,    4,    5,    0,    0,    0,
    0,  109,  107,  108,   47,   48,   12,   11,   53,   54,
    0,   67,    0,    0,   49,   50,   51,   77,   78,   75,
   76,   55,    0,   74,    0,   97,    0,   19,   52,    0,
    0,    0,   94,    0,   95,    0,  110,   96,   72,   21,
   22,   29,   28,   27,   79,    0,   68,   98,   71,    0,
   73,  103,  105,    0,  106,    0,    0,    0,    8,    9,
   10,   64,    0,   80,   66,    0,    0,   13,    0,    0,
   15,   70,   17,   26,    0,    0,    0,  104,    7,    0,
   81,    0,    0,   93,   92,    0,    0,   44,    0,   87,
    0,  101,  100,   82,    0,   56,    0,   24,
};
static const short yydgoto[] = {                         62,
   63,   64,   65,   66,   67,   68,   69,   70,   71,  166,
  115,  116,  167,    0,
};
static const short yysindex[] = {                      -113,
    0, -258, -213, -223, -209, -209,    0,    0,    0,    0,
    0,    0,    0,    0, -209, -209, -209, -209,    0, -216,
 -212, -203,    0, -227,    0, -209, -209, -209, -202, -204,
    0, -201, -200,    0, -199, -207,    0, -198, -197, -209,
 -196, -195, -193, -192, -209, -191, -189, -217, -209, -187,
 -209, -180, -209, -209, -209, -179, -178,    0,    0, -176,
 -209,    0,    0,    0,    0,    0,    0, -173,   23,   23,
   23,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -209,    0, -233, -177,    0,    0,    0,    0,    0,    0,
    0,    0, -172,    0, -171,    0, -170,    0,    0, -209,
 -209, -169,    0, -209,    0, -168,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -217,    0,    0,    0, -167,
    0,    0,    0, -166,    0, -165, -209,   23,    0,    0,
    0,    0, -232,    0,    0, -164, -163,    0, -162, -161,
    0,    0,    0,    0, -160, -159, -158,    0,    0, -157,
    0, -156, -154,    0,    0, -153, -152,    0, -151,    0,
 -150,    0,    0,    0, -209,    0, -209,    0,
};
static const short yyrindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    1,    0,    2,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   58,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    3,    0,    4,    5,    0,    0,    0,    0,    0,    0,
    0,    0,    6,    0,    7,    0,  109,    0,    0,    0,
    0,  110,    0,    8,    0,  111,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    9,    0,    0,    0,   10,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   11,    0,    0,   12,   13,    0,    0,    0,
    0,    0,    0,    0,    0,   14,    0,    0,    0,   15,
    0,   16,   17,    0,    0,    0,    0,    0,   18,    0,
   19,    0,    0,    0,   20,    0,   21,    0,
};
static const short yygindex[] = {                         0,
  -47,    0,    0,    0,    0,    0,    0,    0,    0,  -55,
   -3,    0,   22,    0,
};
#define YYTABLESIZE 348
static const short yytable[] = {                         72,
   91,   62,   63,   86,   65,   90,   61,   69,   25,  102,
   85,   89,   60,   99,   84,   88,   59,   83,   58,   57,
   23,  129,  130,  131,  133,  150,   79,   80,  134,  151,
   88,   89,   90,   91,   75,   76,   81,   82,   83,   84,
  112,   85,  113,  114,   73,   86,   74,   92,   93,   94,
   77,   78,  100,  101,   87,   95,   96,    6,   99,   97,
   98,  104,  102,  103,  105,  106,  109,  107,  108,  110,
  117,  111,  119,  118,  121,  122,  123,  120,  124,  125,
  149,  126,  127,  128,  135,  136,  137,  138,  141,  143,
  145,  146,  147,  152,  153,  154,  155,  156,  157,  158,
  159,  160,  132,  161,  162,  163,  164,  165,   14,   16,
   18,  168,  144,    0,    0,    0,    0,    0,    0,    0,
    0,  139,  140,    0,    0,  142,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  148,    1,
    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
   22,   23,   24,   25,   26,   27,   28,   29,   30,    0,
    0,   31,   32,   33,   34,   35,   36,   37,   38,   39,
   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   91,   62,   63,
   86,   65,   90,   61,   69,   25,  102,   85,   89,   60,
   99,   84,   88,   59,   83,   58,   57,   23,    0,    0,
    0,    0,    0,    0,    0,    1,    0,    0,    4,    5,
    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,    0,    0,   31,    0,    0,
    0,   35,   36,   37,    0,   39,   40,   41,    0,    0,
   44,   45,    0,    0,   48,   49,   50,   51,   52,   53,
   54,   55,   56,   57,   58,   59,   60,   61,
};
static const short yycheck[] = {                        258,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   69,   70,   71,  258,  258,    5,    6,  262,  262,
  258,  259,  260,  261,  258,  259,   15,   16,   17,   18,
  258,  258,  260,  261,  258,  258,  260,   26,   27,   28,
  260,  261,  260,  261,  258,  258,  261,    0,  258,  261,
  261,   40,  261,  261,  261,  261,   45,  261,  261,  261,
   49,  261,   51,  261,   53,   54,   55,  258,  258,  258,
  128,  258,   61,  257,  262,  258,  258,  258,  258,  258,
  258,  258,  258,  258,  258,  258,  258,  258,  258,  258,
  258,  258,   81,  258,  258,  258,  258,  258,    0,    0,
    0,  167,  116,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  100,  101,   -1,   -1,  104,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  127,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,   -1,
   -1,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  257,  257,
  257,  257,  257,  257,  257,  257,  257,  257,  257,  257,
  257,  257,  257,  257,  257,  257,  257,  257,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  263,   -1,   -1,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,   -1,   -1,  295,   -1,   -1,
   -1,  299,  300,  301,   -1,  303,  304,  305,   -1,   -1,
  308,  309,   -1,   -1,  312,  313,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,
};
#define YYFINAL 62
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 325
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"COMMA","NUM","DOUBLE","ID","STR",
"WINSIZ","KW_NOOP","KW_DEFAULT","KW_TAB","KW_SIZE","KW_FORE","KW_BACK",
"KW_LEFT","KW_CENTER","KW_RIGHT","KW_SHRINK","KW_LCUTIN","KW_RCUTIN","KW_CONT",
"KW_NODEF","KW_XFONT","KW_VFONT","KW_IMAGE","KW_BIMAGE","KW_PAGE","KW_HGAP",
"KW_VGAP","KW_GAP","KW_PAUSE","KW_PREFIX","KW_AGAIN","KW_CCOLOR","KW_BAR",
"KW_INCLUDE","KW_BGRAD","KW_TEXT","KW_LINESTART","KW_LINEEND","KW_MARK",
"KW_SYSTEM","KW_FILTER","KW_ENDFILTER","KW_QUALITY","KW_ICON","KW_LEFTFILL",
"KW_XSYSTEM","KW_VFCAP","KW_TFONT","KW_TFDIR","KW_TSYSTEM","KW_DEFFONT",
"KW_FONT","KW_TFONT0","KW_EMBED","KW_ENDEMBED","KW_NEWIMAGE","KW_PSFONT",
"KW_CHARSET","KW_TMFONT","KW_PCACHE","KW_TMFONT0","KW_ANIM","KW_VALIGN",
"KW_AREA","KW_OPAQUE","KW_SUP","KW_SUB","KW_SETSUP","KW_M17N",
};
static const char *yyrule[] = {
"$accept : toplevel",
"toplevel : line",
"toplevel : defaultline",
"toplevel : tabline",
"toplevel : shellline",
"toplevel : deffontline",
"line : cmd",
"line : cmd COMMA line",
"defaultline : defaultcmd line",
"tabline : tabcmd line",
"deffontline : deffontcmd line",
"STRorID : STR",
"STRorID : ID",
"shellline : KW_SYSTEM STR NUM",
"shellline : KW_SYSTEM STR",
"shellline : KW_XSYSTEM STR NUM",
"shellline : KW_XSYSTEM STR",
"shellline : KW_TSYSTEM STR NUM",
"shellline : KW_TSYSTEM STR",
"shellline : KW_FILTER STR",
"shellline : KW_ENDFILTER",
"shellline : KW_EMBED STR",
"shellline : KW_ENDEMBED STR",
"nid : STRorID",
"nid : STRorID nid",
"args : arg",
"args : arg args",
"arg : STR",
"arg : ID",
"arg : NUM",
"cmd : KW_NOOP",
"cmd : KW_LEFT",
"cmd : KW_LEFTFILL",
"cmd : KW_RIGHT",
"cmd : KW_CENTER",
"cmd : KW_SHRINK",
"cmd : KW_LCUTIN",
"cmd : KW_RCUTIN",
"cmd : KW_CONT",
"cmd : KW_NODEF",
"cmd : KW_PAUSE",
"cmd : KW_AGAIN",
"cmd : KW_MARK",
"cmd : KW_PAGE",
"cmd : KW_SETSUP NUM NUM NUM",
"cmd : KW_SUP",
"cmd : KW_SUB",
"cmd : KW_SIZE NUM",
"cmd : KW_SIZE DOUBLE",
"cmd : KW_HGAP NUM",
"cmd : KW_VGAP NUM",
"cmd : KW_GAP NUM",
"cmd : KW_QUALITY NUM",
"cmd : KW_FORE STRorID",
"cmd : KW_BACK STRorID",
"cmd : KW_CCOLOR STRorID",
"cmd : KW_BGRAD NUM NUM NUM NUM NUM nid",
"cmd : KW_BGRAD NUM NUM NUM NUM NUM",
"cmd : KW_BGRAD NUM NUM NUM NUM",
"cmd : KW_BGRAD NUM NUM NUM",
"cmd : KW_BGRAD NUM NUM",
"cmd : KW_BGRAD NUM",
"cmd : KW_BGRAD",
"cmd : KW_XFONT STRorID",
"cmd : KW_XFONT STRorID STRorID",
"cmd : KW_BIMAGE STRorID",
"cmd : KW_BIMAGE STRorID WINSIZ",
"cmd : KW_VFONT STRorID",
"cmd : KW_PSFONT STRorID",
"cmd : KW_TFONT STRorID",
"cmd : KW_TFONT STRorID STRorID",
"cmd : KW_TMFONT STRorID",
"cmd : KW_TFONT0 STRorID",
"cmd : KW_TMFONT0 STRorID",
"cmd : KW_INCLUDE STRorID",
"cmd : KW_PREFIX ID",
"cmd : KW_PREFIX STR",
"cmd : KW_PREFIX NUM",
"cmd : KW_PREFIX DOUBLE",
"cmd : KW_NEWIMAGE args",
"cmd : KW_IMAGE STRorID WINSIZ",
"cmd : KW_IMAGE STRorID NUM WINSIZ",
"cmd : KW_IMAGE STRorID NUM NUM NUM NUM",
"cmd : KW_IMAGE STRorID NUM NUM NUM",
"cmd : KW_IMAGE STRorID NUM NUM",
"cmd : KW_IMAGE STRorID NUM",
"cmd : KW_IMAGE STRorID",
"cmd : KW_BAR STRorID NUM NUM NUM",
"cmd : KW_BAR STRorID NUM NUM",
"cmd : KW_BAR STRorID NUM",
"cmd : KW_BAR STRorID",
"cmd : KW_BAR",
"cmd : KW_ICON STR STRorID NUM",
"cmd : KW_ICON ID STRorID NUM",
"cmd : KW_VFCAP STR",
"cmd : KW_TFDIR STR",
"cmd : KW_FONT STR",
"cmd : KW_TEXT STR",
"cmd : KW_CHARSET STR",
"cmd : KW_AREA NUM NUM",
"cmd : KW_AREA NUM NUM NUM NUM",
"cmd : KW_PCACHE NUM NUM NUM NUM",
"cmd : KW_PCACHE NUM",
"cmd : KW_ANIM STRorID",
"cmd : KW_M17N STRorID STRorID",
"cmd : KW_VALIGN STRorID",
"cmd : KW_OPAQUE NUM",
"tabcmd : KW_TAB NUM",
"tabcmd : KW_TAB ID",
"defaultcmd : KW_DEFAULT NUM",
"deffontcmd : KW_DEFFONT STR",
"enbedded_file :",
"enbedded_file :",

};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;

typedef struct {
    unsigned stacksize;
    short    *s_base;
    short    *s_mark;
    short    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;

#define YYPURE 0

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static YYSTACKDATA yystack;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = data->s_mark - data->s_base;
    newss = (data->s_base != 0)
          ? (short *)realloc(data->s_base, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    data->s_base  = newss;
    data->s_mark = newss + i;

    newvs = (data->l_base != 0)
          ? (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack)) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 1:
#line 801 "./grammar.y"
	{ root = yyval.ct; }
break;
case 2:
#line 802 "./grammar.y"
	{ root = yyval.ct; }
break;
case 3:
#line 803 "./grammar.y"
	{ root = yyval.ct; }
break;
case 4:
#line 804 "./grammar.y"
	{ root = yyval.ct; }
break;
case 5:
#line 805 "./grammar.y"
	{ root = yyval.ct; }
break;
case 6:
#line 807 "./grammar.y"
	{ yyval.ct = yystack.l_mark[0].ct; }
break;
case 7:
#line 808 "./grammar.y"
	{ yyval.ct = yystack.l_mark[-2].ct; yyval.ct->ct_next = yystack.l_mark[0].ct; }
break;
case 8:
#line 810 "./grammar.y"
	{ yyval.ct = yystack.l_mark[-1].ct; yyval.ct->ct_next = yystack.l_mark[0].ct; }
break;
case 9:
#line 812 "./grammar.y"
	{ yyval.ct = yystack.l_mark[-1].ct; yyval.ct->ct_next = yystack.l_mark[0].ct; }
break;
case 10:
#line 814 "./grammar.y"
	{ yyval.ct = yystack.l_mark[-1].ct; yyval.ct->ct_next = yystack.l_mark[0].ct; }
break;
case 12:
#line 817 "./grammar.y"
	{ yywarn("\"%s\" should be quoted", yystack.l_mark[0].s); }
break;
case 13:
#line 820 "./grammar.y"
	{ yyval.ct = gen_argsfromstr(CTL_SYSTEM, yystack.l_mark[-1].s, yystack.l_mark[0].i); }
break;
case 14:
#line 821 "./grammar.y"
	{ yyval.ct = gen_argsfromstr(CTL_SYSTEM, yystack.l_mark[0].s, 0); }
break;
case 15:
#line 822 "./grammar.y"
	{ yyval.ct = gen_argsfromstr(CTL_XSYSTEM, yystack.l_mark[-1].s, yystack.l_mark[0].i); }
break;
case 16:
#line 823 "./grammar.y"
	{ yyval.ct = gen_argsfromstr(CTL_XSYSTEM, yystack.l_mark[0].s, 0); }
break;
case 17:
#line 824 "./grammar.y"
	{ yyval.ct = gen_argsfromstr(CTL_TSYSTEM, yystack.l_mark[-1].s, yystack.l_mark[0].i); }
break;
case 18:
#line 825 "./grammar.y"
	{ yyval.ct = gen_argsfromstr(CTL_TSYSTEM, yystack.l_mark[0].s, 0); }
break;
case 19:
#line 826 "./grammar.y"
	{ yyval.ct = gen_argsfromstr(CTL_FILTER, yystack.l_mark[0].s, 0); }
break;
case 20:
#line 827 "./grammar.y"
	{ yyval.ct = gen_void(CTL_ENDFILTER); }
break;
case 21:
#line 828 "./grammar.y"
	{ yyval.ct = gen_str(CTL_EMBED, yystack.l_mark[0].s); }
break;
case 22:
#line 829 "./grammar.y"
	{ yyval.ct = gen_void(CTL_ENDEMBED); }
break;
case 23:
#line 831 "./grammar.y"
	{ yyval.ct = gen_str(CTL_NOOP, yystack.l_mark[0].s); }
break;
case 24:
#line 832 "./grammar.y"
	{ yyval.ct = gen_str(CTL_NOOP, yystack.l_mark[-1].s); yyval.ct->ct_next = yystack.l_mark[0].ct; }
break;
case 25:
#line 834 "./grammar.y"
	{ yyval.ct = yystack.l_mark[0].ct; }
break;
case 26:
#line 835 "./grammar.y"
	{ yyval.ct = yystack.l_mark[-1].ct; yyval.ct->ct_next = yystack.l_mark[0].ct; }
break;
case 27:
#line 837 "./grammar.y"
	{ yyval.ct = gen_str(CTL_NOOP, yystack.l_mark[0].s); }
break;
case 28:
#line 838 "./grammar.y"
	{ yyval.ct = gen_str(CTL_NOOP, yystack.l_mark[0].s); }
break;
case 29:
#line 839 "./grammar.y"
	{ char buf[30];
			  snprintf(buf, sizeof(buf), "%d", yystack.l_mark[0].i);
			  yyval.ct = gen_str(CTL_NOOP, buf);
			}
break;
case 30:
#line 844 "./grammar.y"
	{ yyval.ct = gen_void(CTL_NOOP); }
break;
case 31:
#line 845 "./grammar.y"
	{ yyval.ct = gen_void(CTL_LEFT); }
break;
case 32:
#line 846 "./grammar.y"
	{ yyval.ct = gen_void(CTL_LEFTFILL); }
break;
case 33:
#line 847 "./grammar.y"
	{ yyval.ct = gen_void(CTL_RIGHT); }
break;
case 34:
#line 848 "./grammar.y"
	{ yyval.ct = gen_void(CTL_CENTER); }
break;
case 35:
#line 849 "./grammar.y"
	{ yyval.ct = gen_void(CTL_SHRINK); }
break;
case 36:
#line 850 "./grammar.y"
	{ yyval.ct = gen_void(CTL_LCUTIN); }
break;
case 37:
#line 851 "./grammar.y"
	{ yyval.ct = gen_void(CTL_RCUTIN); }
break;
case 38:
#line 852 "./grammar.y"
	{ yyval.ct = gen_void(CTL_CONT); }
break;
case 39:
#line 853 "./grammar.y"
	{ yyval.ct = gen_void(CTL_NODEF); }
break;
case 40:
#line 854 "./grammar.y"
	{ yyval.ct = gen_int(CTL_PAUSE, 0); }
break;
case 41:
#line 855 "./grammar.y"
	{ yyval.ct = gen_void(CTL_AGAIN); }
break;
case 42:
#line 856 "./grammar.y"
	{ yyval.ct = gen_void(CTL_MARK); }
break;
case 43:
#line 857 "./grammar.y"
	{ yyval.ct = gen_void(CTL_PAGE); }
break;
case 44:
#line 858 "./grammar.y"
	{ yyval.ct = gen_int3(CTL_SETSUP, yystack.l_mark[-2].i, yystack.l_mark[-1].i, yystack.l_mark[0].i); }
break;
case 45:
#line 859 "./grammar.y"
	{ yyval.ct = gen_void(CTL_SUP); }
break;
case 46:
#line 860 "./grammar.y"
	{ yyval.ct = gen_void(CTL_SUB); }
break;
case 47:
#line 861 "./grammar.y"
	{ yyval.ct = gen_double_int(CTL_SIZE, yystack.l_mark[0].i); }
break;
case 48:
#line 862 "./grammar.y"
	{ yyval.ct = gen_double(CTL_SIZE, yystack.l_mark[0].d); }
break;
case 49:
#line 863 "./grammar.y"
	{ yyval.ct = gen_int(CTL_HGAP, yystack.l_mark[0].i); }
break;
case 50:
#line 864 "./grammar.y"
	{ yyval.ct = gen_int(CTL_VGAP, yystack.l_mark[0].i); }
break;
case 51:
#line 865 "./grammar.y"
	{ yyval.ct = gen_int(CTL_GAP, yystack.l_mark[0].i); }
break;
case 52:
#line 867 "./grammar.y"
	{ if (!quality_flag)
				yyval.ct = gen_int(CTL_QUALITY, yystack.l_mark[0].i);
			  else
				yyval.ct = ctlalloc1(CTL_NOOP);
			}
break;
case 53:
#line 872 "./grammar.y"
	{ yyval.ct = gen_color(CTL_FORE, yystack.l_mark[0].s); }
break;
case 54:
#line 873 "./grammar.y"
	{ yyval.ct = gen_color(CTL_BACK, yystack.l_mark[0].s); }
break;
case 55:
#line 874 "./grammar.y"
	{ yyval.ct = gen_color(CTL_CCOLOR, yystack.l_mark[0].s); }
break;
case 56:
#line 876 "./grammar.y"
	{ yyval.ct = gen_bgrad(yystack.l_mark[-5].i, yystack.l_mark[-4].i, yystack.l_mark[-3].i, yystack.l_mark[-2].i, yystack.l_mark[-1].i, yystack.l_mark[0].ct); }
break;
case 57:
#line 878 "./grammar.y"
	{ yyval.ct = gen_bgrad(yystack.l_mark[-4].i, yystack.l_mark[-3].i, yystack.l_mark[-2].i, yystack.l_mark[-1].i, yystack.l_mark[0].i,
				(struct ctrl *)NULL);
			}
break;
case 58:
#line 882 "./grammar.y"
	{ yyval.ct = gen_bgrad(yystack.l_mark[-3].i, yystack.l_mark[-2].i, yystack.l_mark[-1].i, yystack.l_mark[0].i, 1,
				(struct ctrl *)NULL);
			}
break;
case 59:
#line 886 "./grammar.y"
	{ yyval.ct = gen_bgrad(yystack.l_mark[-2].i, yystack.l_mark[-1].i, yystack.l_mark[0].i, 0, 1,
				(struct ctrl *)NULL);
			}
break;
case 60:
#line 890 "./grammar.y"
	{ yyval.ct = gen_bgrad(yystack.l_mark[-1].i, yystack.l_mark[0].i, DEFAULT_GRADCOLORS, 0, 1,
					(struct ctrl *)NULL);
			}
break;
case 61:
#line 893 "./grammar.y"
	{ yyval.ct = gen_bgrad(yystack.l_mark[0].i, 100, DEFAULT_GRADCOLORS, 0, 1,
					(struct ctrl *)NULL);
			}
break;
case 62:
#line 896 "./grammar.y"
	{ yyval.ct = gen_bgrad(100, 100, DEFAULT_GRADCOLORS, 0, 1,
					(struct ctrl *)NULL);
			}
break;
case 63:
#line 900 "./grammar.y"
	{ char *p;
			  if (strncmp(yystack.l_mark[0].s, "medium", 6) == 0
			   || strncmp(yystack.l_mark[0].s, "bold", 4) == 0) {
				/* for backward compatibility */
				p = malloc(strlen(yystack.l_mark[0].s) + 1 + 6);
				sprintf(p, "times-%s", yystack.l_mark[0].s);
			  } else
				p = yystack.l_mark[0].s;
			  check_xfont(p, "iso8859-1"); /* lexical check */
			  yyval.ct = gen_str2(CTL_XFONT2, p, "iso8859-1");
			}
break;
case 64:
#line 912 "./grammar.y"
	{ check_xfont(yystack.l_mark[-1].s, yystack.l_mark[0].s);	/* lexical check */
			  yyval.ct = gen_str2(CTL_XFONT2, yystack.l_mark[-1].s, yystack.l_mark[0].s);
			}
break;
case 65:
#line 915 "./grammar.y"
	{ yyval.ct = gen_image(CTL_BIMAGE, yystack.l_mark[0].s, 0, 0, 0, 0); }
break;
case 66:
#line 917 "./grammar.y"
	{ int x, y;
			  x = atoi(yystack.l_mark[0].s); y = atoi(strchr(yystack.l_mark[0].s, 'x') + 1);
			  yyval.ct = gen_image(CTL_BIMAGE, yystack.l_mark[-1].s, 0, x, y, 2);
			}
break;
case 67:
#line 921 "./grammar.y"
	{
#ifdef VFLIB
				  yyval.ct = gen_str(CTL_VFONT, yystack.l_mark[0].s);
#else
				  yyval.ct = gen_str(CTL_NOOP, yystack.l_mark[0].s);
				  yywarn("directive \"vfont\" not supported "
					"in this configuration");
#endif
				}
break;
case 68:
#line 930 "./grammar.y"
	{
					yyval.ct = gen_str2(CTL_PSFONT, yystack.l_mark[0].s, "iso8859-1");
				}
break;
case 69:
#line 933 "./grammar.y"
	{
#ifdef FREETYPE
				  yyval.ct = gen_str2(CTL_TFONT, yystack.l_mark[0].s, "iso8859-1");
#else
				  yyval.ct = gen_str2(CTL_NOOP, yystack.l_mark[0].s, "iso8859-1");
				  yywarn("directive \"tfont\" not supported "
					"in this configuration");
#endif
				}
break;
case 70:
#line 942 "./grammar.y"
	{
#ifdef FREETYPE
				  yyval.ct = gen_str2(CTL_TFONT, yystack.l_mark[-1].s, yystack.l_mark[0].s);
#else
				  yyval.ct = gen_str2(CTL_NOOP, yystack.l_mark[-1].s, yystack.l_mark[0].s);
				  yywarn("directive \"tfont\" not supported "
					"in this configuration");
#endif
				}
break;
case 71:
#line 952 "./grammar.y"
	{
#ifdef FREETYPE
				  yyval.ct = gen_str(CTL_TMFONT, yystack.l_mark[0].s);
#else
				  yyval.ct = gen_str(CTL_NOOP, yystack.l_mark[0].s);
				  yywarn("directive \"tmfont\" not supported "
					"in this configuration");
#endif
				}
break;
case 72:
#line 961 "./grammar.y"
	{
#ifdef FREETYPE
				  yyval.ct = gen_str(CTL_TFONT0, yystack.l_mark[0].s);
#else
				  yyval.ct = gen_str(CTL_NOOP, yystack.l_mark[0].s);
				  yywarn("directive \"tfont0\" not supported "
					"in this configuration");
#endif
				}
break;
case 73:
#line 970 "./grammar.y"
	{
#ifdef FREETYPE_CHARSET16
				  yyval.ct = gen_str(CTL_TMFONT0, yystack.l_mark[0].s);
#else
				  yyval.ct = gen_str(CTL_NOOP, yystack.l_mark[0].s);
				  yywarn("directive \"tmfont0\" not supported "
					"in this configuration");
#endif
				}
break;
case 74:
#line 979 "./grammar.y"
	{ yyval.ct = gen_str(CTL_INCLUDE, yystack.l_mark[0].s); }
break;
case 75:
#line 980 "./grammar.y"
	{ char *p;
			  yyval.ct = gen_str(CTL_PREFIX, yystack.l_mark[0].s);
			  for (p = yyval.ct->ctc_value; *p; p++) {
				if (*p == '_') *p = ' ';
			  }
			}
break;
case 76:
#line 986 "./grammar.y"
	{ yyval.ct = gen_str(CTL_PREFIX, yystack.l_mark[0].s); }
break;
case 77:
#line 987 "./grammar.y"
	{ yyval.ct = gen_double_int(CTL_PREFIXN, yystack.l_mark[0].i); }
break;
case 78:
#line 988 "./grammar.y"
	{ yyval.ct = gen_double(CTL_PREFIXN, yystack.l_mark[0].d); }
break;
case 79:
#line 990 "./grammar.y"
	{ yyval.ct = gen_newimage(yystack.l_mark[0].ct); }
break;
case 80:
#line 992 "./grammar.y"
	{ int x, y;
			  x = atoi(yystack.l_mark[0].s); y = atoi(strchr(yystack.l_mark[0].s, 'x') + 1);
			  yyval.ct = gen_image(CTL_IMAGE, yystack.l_mark[-1].s, 0, x, y, 2);
			}
break;
case 81:
#line 997 "./grammar.y"
	{ int x, y;
			  x = atoi(yystack.l_mark[0].s); y = atoi(strchr(yystack.l_mark[0].s, 'x') + 1);
			  yyval.ct = gen_image(CTL_IMAGE, yystack.l_mark[-2].s, yystack.l_mark[-1].i, x, y, 2);
			}
break;
case 82:
#line 1002 "./grammar.y"
	{ yyval.ct = gen_image(CTL_IMAGE, yystack.l_mark[-4].s, yystack.l_mark[-3].i, yystack.l_mark[-2].i, yystack.l_mark[-1].i, yystack.l_mark[0].i ? 1 : 0); }
break;
case 83:
#line 1004 "./grammar.y"
	{ yyval.ct = gen_image(CTL_IMAGE, yystack.l_mark[-3].s, yystack.l_mark[-2].i, yystack.l_mark[-1].i, yystack.l_mark[0].i, 0); }
break;
case 84:
#line 1006 "./grammar.y"
	{ yyval.ct = gen_image(CTL_IMAGE, yystack.l_mark[-2].s, yystack.l_mark[-1].i, yystack.l_mark[0].i, 0, 0); }
break;
case 85:
#line 1008 "./grammar.y"
	{ yyval.ct = gen_image(CTL_IMAGE, yystack.l_mark[-1].s, yystack.l_mark[0].i, 0, 0, 0); }
break;
case 86:
#line 1009 "./grammar.y"
	{ yyval.ct = gen_image(CTL_IMAGE, yystack.l_mark[0].s, 0, 0, 0, 0); }
break;
case 87:
#line 1011 "./grammar.y"
	{ yyval.ct = gen_bar(yystack.l_mark[-3].s, yystack.l_mark[-2].i, yystack.l_mark[-1].i, yystack.l_mark[0].i); }
break;
case 88:
#line 1013 "./grammar.y"
	{ yyval.ct = gen_bar(yystack.l_mark[-2].s, yystack.l_mark[-1].i, yystack.l_mark[0].i, 100); }
break;
case 89:
#line 1014 "./grammar.y"
	{ yyval.ct = gen_bar(yystack.l_mark[-1].s, yystack.l_mark[0].i, 0, 100); }
break;
case 90:
#line 1015 "./grammar.y"
	{ yyval.ct = gen_bar(yystack.l_mark[0].s, 10, 0, 100); }
break;
case 91:
#line 1016 "./grammar.y"
	{ yyval.ct = gen_bar("black", 10, 0, 100); }
break;
case 92:
#line 1018 "./grammar.y"
	{ yyval.ct = gen_icon(yystack.l_mark[-2].s, yystack.l_mark[-1].s, yystack.l_mark[0].i); }
break;
case 93:
#line 1020 "./grammar.y"
	{ yyval.ct = gen_icon(yystack.l_mark[-2].s, yystack.l_mark[-1].s, yystack.l_mark[0].i); }
break;
case 94:
#line 1021 "./grammar.y"
	{
#ifdef VFLIB
			  yyval.ct = gen_str(CTL_VFCAP, yystack.l_mark[0].s);
#else
			  yyval.ct = gen_str(CTL_NOOP, yystack.l_mark[0].s);
			  yywarn("directive \"vfcap\" not supported "
				"in this configuration");
#endif
			}
break;
case 95:
#line 1030 "./grammar.y"
	{
#ifdef FREETYPE
			  yyval.ct = gen_str(CTL_TFDIR, yystack.l_mark[0].s);
#else
			  yyval.ct = gen_str(CTL_NOOP, yystack.l_mark[0].s);
			  yywarn("directive \"tfdir\" not supported "
				"in this configuration");
#endif
			}
break;
case 96:
#line 1039 "./grammar.y"
	{ yyval.ct = gen_str(CTL_FONT, yystack.l_mark[0].s); }
break;
case 97:
#line 1040 "./grammar.y"
	{ yyval.ct = gen_str(CTL_TEXT, yystack.l_mark[0].s); }
break;
case 98:
#line 1041 "./grammar.y"
	{ yyval.ct = gen_str(CTL_CHARSET, yystack.l_mark[0].s); }
break;
case 99:
#line 1042 "./grammar.y"
	{ yyval.ct = gen_area(yystack.l_mark[-1].i, yystack.l_mark[0].i, -1, -1); }
break;
case 100:
#line 1043 "./grammar.y"
	{ yyval.ct = gen_area(yystack.l_mark[-3].i, yystack.l_mark[-2].i, yystack.l_mark[-1].i, yystack.l_mark[0].i); }
break;
case 101:
#line 1045 "./grammar.y"
	{ yyval.ct = gen_pcache(yystack.l_mark[-3].i, yystack.l_mark[-2].i, yystack.l_mark[-1].i, yystack.l_mark[0].i); }
break;
case 102:
#line 1047 "./grammar.y"
	{ yyval.ct = gen_pcache(yystack.l_mark[0].i, 0, 0, 0); }
break;
case 103:
#line 1048 "./grammar.y"
	{
#ifdef MNG
			yyval.ct = gen_str(CTL_ANIM, yystack.l_mark[0].s);
			chkfile(yystack.l_mark[0].s);
#else
			yyval.ct = gen_str(CTL_NOOP, yystack.l_mark[0].s);
			yywarn("directive \"anim\" not supported "
					"in this configuration");
#endif
	}
break;
case 104:
#line 1058 "./grammar.y"
	{
#ifdef USE_M17N
			yyval.ct = gen_str2(CTL_M17N, yystack.l_mark[-1].s, yystack.l_mark[0].s);
#else
			yyval.ct = gen_str2(CTL_NOOP, yystack.l_mark[-1].s, yystack.l_mark[0].s);
			yywarn("directive \"m17n\" not supported "
					"in this configuration");
#endif
	}
break;
case 105:
#line 1067 "./grammar.y"
	{
			yyval.ct = gen_valign(yystack.l_mark[0].s);
	}
break;
case 106:
#line 1070 "./grammar.y"
	{ yyval.ct = gen_int(CTL_OPAQUE, yystack.l_mark[0].i); }
break;
case 107:
#line 1072 "./grammar.y"
	{ yyval.ct = gen_int(CTL_TAB, yystack.l_mark[0].i); }
break;
case 108:
#line 1073 "./grammar.y"
	{ yyval.ct = gen_str(CTL_TAB, yystack.l_mark[0].s); }
break;
case 109:
#line 1076 "./grammar.y"
	{ yyval.ct = gen_int(CTL_DEFAULT, yystack.l_mark[0].i); }
break;
case 110:
#line 1079 "./grammar.y"
	{ yyval.ct = gen_str(CTL_DEFFONT, yystack.l_mark[0].s); }
break;
#line 1998 "y.tab.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (short) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
